// CISaver.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "GLWnd.h"
#include "SaverWnd.h"
#include "CISaver.h"
#include "CISaverDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCISaverApp

BEGIN_MESSAGE_MAP(CCISaverApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CCISaverApp construction

CCISaverApp::CCISaverApp()
{
	m_pglwnd=0;
	m_psvwnd=0;
}


// The one and only CCISaverApp object

CCISaverApp theApp;




// CCISaverApp initialization

BOOL CCISaverApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	InitCommonControls();
	SetRegistryKey("CISaver");
	CWinApp::InitInstance();
  AfxEnableControlContainer();
	CString cmdln=m_lpCmdLine;
	int pos=0;
	CString tok=cmdln.Tokenize(" :",pos);
	//AfxMessageBox(cmdln);
	if (    !tok.CompareNoCase("/s") 
    	||  !tok.CompareNoCase("-s") 
    	||  !tok.CompareNoCase("s"))
    {
			DoScreenSaver();      // Run as screen saver
	    return TRUE;
    }
		if (  !tok.CompareNoCase("/c") 
			||  !tok.CompareNoCase("-c") 
			||  !tok.CompareNoCase("c")	 
			)
    {
       // Run config with current window as parent
       DoSaverSetting();

      // Now just terminate
      return FALSE;
    }
		if (  !tok.CompareNoCase("/p")  
			||  !tok.CompareNoCase("-p") 
			||  !tok.CompareNoCase("p") )
    {
     // Run config with current window as parent
          DoSaverPreview();//CWnd::GetActiveWindow());

      // Now just terminate
      return TRUE;
    }

	//  Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CCISaverApp::DoSaverSetting(void)
{	
	CCISaverDlg dlg;
	
	//AfxMessageBox("DoSaverSetting");
	CString tok,cmdln=m_lpCmdLine;
	int pos=0;
	tok=cmdln.Tokenize(": ",pos); 	//AfxMessageBox(tok);
	tok=cmdln.Tokenize(": ",pos); 	//AfxMessageBox(tok);

	if(tok.GetLength()>0)
	{
		AfxMessageBox(tok);
		TRACE("Second token in command line is '%s'\n",tok);
		CWnd* pParent = CWnd::FromHandle((HWND)atol(tok));
		ASSERT(pParent != NULL);
		//dlg.SetParent(pParent);
	}
  ReadSetting();
	dlg.m_filename=	filename;
  m_pMainWnd = &dlg;
	if (dlg.DoModal() == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
	    //dlg.GetData(&m_sSetting);
		  filename=dlg.m_filename;
      WriteSetting();
	}
}

void CCISaverApp::DoScreenSaver(void)
{	
	TRACE("CCISaverApp::DoScreenSaver()\n");
  m_psvwnd = new CSaverWnd;
  ReadSetting();
	m_psvwnd->Create();
	m_pMainWnd = m_psvwnd;
	TRACE("exiting CCISaverApp::DoScreenSaver(void)\n");
}

void CCISaverApp::DoSaverPreview(void)
{	
	CString tok,cmdln=m_lpCmdLine;
	int pos=0;
	tok=cmdln.Tokenize(" ",pos); //	AfxMessageBox(tok);
	tok=cmdln.Tokenize(" ",pos); //	AfxMessageBox(tok);
	TRACE("Second token in command line is '%s'\n",tok);
	CWnd* pParent = CWnd::FromHandle((HWND)atol(tok));
	ASSERT(pParent != NULL);
	CGLWnd* pWnd = new CGLWnd();
  ReadSetting();
  CRect rect;
	pParent->GetClientRect(&rect);
	pWnd->myCreate(NULL, WS_VISIBLE|WS_CHILD, rect, pParent,0);
	m_pMainWnd = pWnd;
}
void CCISaverApp::ReadSetting()
{
	filename=GetProfileString( "CISaver", "Filename", "none");
}
void CCISaverApp::WriteSetting()
{
	WriteProfileString("CISaver", "Filename",filename);
}




int CCISaverApp::ExitInstance()
{
TRACE("Cleaning...\n\n" );
if(m_pglwnd) delete m_pglwnd;
if(m_psvwnd) delete m_psvwnd;

	return CWinApp::ExitInstance();
}
